<template>
  <v-row class="my-profile">
    <v-col cols="2" class="profile__item">
      <VImageInput
        v-if="isAvatarEditing"
        v-model="avatar"
        clearable
        image-format="jpeg"
        class="profile__avatar-input"
        :imageWidth="170"
        :imageHeight="170"
        imageMinScaling="contain"
      />
      <v-avatar v-else class="profile__avatar" size="150" @click="isAvatarEditing = true">
        <img
          :src="userAvatar"
          alt="Avatar"
        />
      </v-avatar>
    </v-col>
    <v-col cols="2">
      <v-text-field
        v-model="firstName"
        label="Name"
        rounded filled outlined>
      </v-text-field>
      <v-text-field
        v-model="lastName"
        label="Surname"
        rounded filled outlined>
      </v-text-field>
    </v-col>
    <v-col cols="2" class="profile__item">
      <v-btn
        @click="updateProfile"
        :disabled="disabled"
        class="dark-btn profile__save">
        Save
      </v-btn>
    </v-col>
  </v-row>
</template>

<script>
import VImageInput from 'vuetify-image-input'
import { mapMutations, mapGetters } from 'vuex'
import { UpdateAvatar, UpdateProfile } from '@/api/users'
import { newAvatarS3Link } from "@/js/s3"

export default {
  name: 'MyProfile',

  components: {
    VImageInput
  },

  data () {
    return {
      avatar: "",

      firstName: "",
      lastName: "",
      isAvatarEditing: false,
      disabled: false
    }
  },

  computed: {
    ...mapGetters([
      'userFirstName',
      'userLastName',
      'userID',
      'userAvatar'
    ])
  },

  methods: {
    ...mapMutations([
      'updateUserAvatar',
      'updateUserFirstName',
      'updateUserLastName'
    ]),

    async updateProfile() {
      this.disabled = true
      try {
        if (this.avatar && !await this.updateAvatar()) {
          return
        }

        if (this.userFirstName !== this.firstName || this.userLastName !== this.lastName) {
          const status = await UpdateProfile(this.firstName, this.lastName, this.userID)
          if (!status) {
            return
          }

          if (status === 200) {
            this.isAvatarEditing = false
            this.updateUserFirstName(this.firstName)
            this.updateUserLastName(this.lastName)
          } else {
            this.$toasted.error('Oh no... Something bad happened')
            return
          }
        }

        this.$toasted.success('Successfully saved')
      } finally {
        this.disabled = false
      }
    },

    async updateAvatar() {
      const blob = this.dataURItoBlob(this.avatar)
      const bodyFormData = new FormData()
      bodyFormData.append('avatar', blob)

      const status = await UpdateAvatar(bodyFormData, this.userID)
      if (!status) {
        return
      }

      if (status === 200) {
        this.updateUserAvatar(newAvatarS3Link(this.userID))
        this.isAvatarEditing = false
      } else {
        this.$toasted.error('Oh no... Something bad happened')
        return false
      }
      return true
    },

    dataURItoBlob(dataURI) {
      const byteString = atob(dataURI.split(',')[1])
      const mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0]

      const ab = new ArrayBuffer(byteString.length)
      const ia = new Uint8Array(ab)
      for (let i = 0; i < byteString.length; i++) {
        ia[i] = byteString.charCodeAt(i)
      }

      return new Blob([ab], { type: mimeString })
    }
  },

  created() {
    this.firstName = this.userFirstName
    this.lastName = this.userLastName
  },

  watch: {
    avatar: function (val) {
      if (!val) {
        this.isAvatarEditing = false
        this.avatar = ""
      }
    }
  }
}
</script>

<style>
.profile__avatar-input {
  width: 300px;
  height: 300px;
}

.profile__avatar {
  background-color: #000;
  border-style: groove;
  border-width: 1px;
  border-color: rgba(51, 51, 51, 0.6);
}

.profile__avatar:hover {
  cursor: pointer;
}

.profile__save {
  font-family: 'Nunito', fantasy;
  font-style: normal;
  font-weight: 600 !important;
}

.profile__item {
  display: grid;
  place-items: center;
}

.my-profile {
  margin-top: 100px !important;
  display: grid !important;
  place-items: center !important;
}
</style>
